package com.zt.plat.module.qms.business.config.service;

import cn.hutool.core.collection.CollUtil;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigProjectPageReqVO;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigProjectRespVO;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigProjectSaveReqVO;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;

import java.util.*;
import com.zt.plat.module.qms.business.config.controller.vo.*;
import com.zt.plat.module.qms.business.config.dal.dataobject.ConfigProjectDO;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.common.util.object.BeanUtils;

import com.zt.plat.module.qms.business.config.dal.mapper.ConfigProjectMapper;

import static com.zt.plat.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.zt.plat.framework.common.util.collection.CollectionUtils.convertList;
import static com.zt.plat.module.qms.enums.ErrorCodeConstants.CONFIG_PROJECT_NOT_EXISTS;

/**
 * 检测项目配置 Service 实现类
 *
 * @author 后台管理
 */
@Service
@Validated
public class ConfigProjectServiceImpl implements ConfigProjectService {

    @Resource
    private ConfigProjectMapper configProjectMapper;

    @Override
    public ConfigProjectRespVO createConfigProject(ConfigProjectSaveReqVO createReqVO) {
        // 插入
        ConfigProjectDO configProject = BeanUtils.toBean(createReqVO, ConfigProjectDO.class);
        configProjectMapper.insert(configProject);
        // 返回
        return BeanUtils.toBean(configProject, ConfigProjectRespVO.class);
    }

    @Override
    public void updateConfigProject(ConfigProjectSaveReqVO updateReqVO) {
        // 校验存在
        validateConfigProjectExists(updateReqVO.getId());
        // 更新
        ConfigProjectDO updateObj = BeanUtils.toBean(updateReqVO, ConfigProjectDO.class);
        configProjectMapper.updateById(updateObj);
    }

    @Override
    public void deleteConfigProject(Long id) {
        // 校验存在
        validateConfigProjectExists(id);
        // 删除
        configProjectMapper.deleteById(id);
    }

    @Override
        public void deleteConfigProjectListByIds(List<Long> ids) {
        // 校验存在
        validateConfigProjectExists(ids);
        // 删除
        configProjectMapper.deleteByIds(ids);
        }

    private void validateConfigProjectExists(List<Long> ids) {
        List<ConfigProjectDO> list = configProjectMapper.selectByIds(ids);
        if (CollUtil.isEmpty(list) || list.size() != ids.size()) {
            throw exception(CONFIG_PROJECT_NOT_EXISTS);
        }
    }

    private void validateConfigProjectExists(Long id) {
        if (configProjectMapper.selectById(id) == null) {
            throw exception(CONFIG_PROJECT_NOT_EXISTS);
        }
    }

    @Override
    public ConfigProjectDO getConfigProject(Long id) {
        return configProjectMapper.selectById(id);
    }

    @Override
    public PageResult<ConfigProjectDO> getConfigProjectPage(ConfigProjectPageReqVO pageReqVO) {
        return configProjectMapper.selectPage(pageReqVO);
    }

}